accounting/apps/books/urls.py
from django.conf.urls import patterns, url

from . import views


urlpatterns = patterns('',
    url(r'^$',
        views.DashboardView.as_view(),
        name="dashboard"),

    # Organizations
    url(r'^organization/$',
        views.OrganizationListView.as_view(),
        name="organization-list"),
    url(r'^organization/selector/$',
        views.OrganizationSelectorView.as_view(),
        name="organization-selector"),
    url(r'^organization/create/$',
        views.OrganizationCreateView.as_view(),
        name="organization-create"),
    url(r'^organization/(?P<pk>\d+)/edit/$',
        views.OrganizationUpdateView.as_view(),
        name="organization-edit"),
    url(r'^organization/(?P<pk>\d+)/detail/$',
        views.OrganizationDetailView.as_view(),
        name="organization-detail"),
    url(r'^organization/(?P<pk>\d+)/select/$',
        views.OrganizationSelectionView.as_view(),
        name="organization-select"),

    # Tax Rates
    url(r'^tax_rates/$',
        views.TaxRateListView.as_view(),
        name="tax_rate-list"),
    url(r'^tax_rates/create/$',
        views.TaxRateCreateView.as_view(),
        name="tax_rate-create"),
    url(r'^tax_rates/(?P<pk>\d+)/edit/$',
        views.TaxRateUpdateView.as_view(),
        name="tax_rate-edit"),
    url(r'^tax_rates/(?P<pk>\d+)/delete/$',
        views.TaxRateDeleteView.as_view(),
        name="tax_rate-delete"),

    # Estimates
    url(r'^estimate/$',
        views.EstimateListView.as_view(),
        name="estimate-list"),
    url(r'^estimate/create/$',
        views.EstimateCreateView.as_view(),
        name="estimate-create"),
    url(r'^estimate/(?P<pk>\d+)/edit/$',
        views.EstimateUpdateView.as_view(),
        name="estimate-edit"),
    url(r'^estimate/(?P<pk>\d+)/delete/$',
        views.EstimateDeleteView.as_view(),
        name="estimate-delete"),
    url(r'^estimate/(?P<pk>\d+)/detail/$',
        views.EstimateDetailView.as_view(),
        name="estimate-detail"),

    # Invoices
    url(r'^invoice/$',
        views.InvoiceListView.as_view(),
        name="invoice-list"),
    url(r'^invoice/create/$',
        views.InvoiceCreateView.as_view(),
        name="invoice-create"),
    url(r'^invoice/(?P<pk>\d+)/edit/$',
        views.InvoiceUpdateView.as_view(),
        name="invoice-edit"),
    url(r'^invoice/(?P<pk>\d+)/delete/$',
        views.InvoiceDeleteView.as_view(),
        name="invoice-delete"),
    url(r'^invoice/(?P<pk>\d+)/detail/$',
        views.InvoiceDetailView.as_view(),
        name="invoice-detail"),

    # Bills
    url(r'^bill/$',
        views.BillListView.as_view(),
        name="bill-list"),
    url(r'^bill/create/$',
        views.BillCreateView.as_view(),
        name="bill-create"),
    url(r'^bill/(?P<pk>\d+)/edit/$',
        views.BillUpdateView.as_view(),
        name="bill-edit"),
    url(r'^bill/(?P<pk>\d+)/delete/$',
        views.BillDeleteView.as_view(),
        name="bill-delete"),
    url(r'^bill/(?P<pk>\d+)/detail/$',
        views.BillDetailView.as_view(),
        name="bill-detail"),

    # ExpenseClaims
    url(r'^expense-claim/$',
        views.ExpenseClaimListView.as_view(),
        name="expense_claim-list"),
    url(r'^expense-claim/create/$',
        views.ExpenseClaimCreateView.as_view(),
        name="expense_claim-create"),
    url(r'^expense-claim/(?P<pk>\d+)/edit/$',
        views.ExpenseClaimUpdateView.as_view(),
        name="expense_claim-edit"),
    url(r'^expense-claim/(?P<pk>\d+)/delete/$',
        views.ExpenseClaimDeleteView.as_view(),
        name="expense_claim-delete"),
    url(r'^expense-claim/(?P<pk>\d+)/detail/$',
        views.ExpenseClaimDetailView.as_view(),
        name="expense_claim-detail"),

    # Payments
    url(r'^payment/(?P<pk>\d+)/edit/$',
        views.PaymentUpdateView.as_view(),
        name="payment-edit"),
    url(r'^payment/(?P<pk>\d+)/delete/$',
        views.PaymentDeleteView.as_view(),
        name="payment-delete"),
)

accounting/urls.py
from django.conf import settings
from django.conf.urls import patterns, include, url
from django.conf.urls.static import static


urlpatterns = patterns('',
    url(r'^', include('accounting.apps.connect.urls',
        namespace="connect")),
    url(r'^books/', include('accounting.apps.books.urls',
        namespace="books")),
    url(r'^people/', include('accounting.apps.people.urls',
        namespace="people")),
    url(r'^reports/', include('accounting.apps.reports.urls',
        namespace="reports")),

    # third party
    url(r'^select2/', include('django_select2.urls')),
)

if settings.DEBUG:
    urlpatterns += static(settings.MEDIA_URL,
                          document_root=settings.MEDIA_ROOT)

accounting/apps/books/views.py
import logging
from decimal import Decimal as D

from django.views import generic
from django.core.urlresolvers import reverse, reverse_lazy
from django.db.models import Sum
from django.http import HttpResponseRedirect

from .mixins import (
    RestrictToSelectedOrganizationQuerySetMixin,
    SaleListQuerySetMixin,
    AutoSetSelectedOrganizationMixin,
    AbstractSaleCreateUpdateMixin,
    AbstractSaleDetailMixin,
    PaymentFormMixin)
from .models import (
    Organization,
    TaxRate,
    Estimate,
    Invoice,
    Bill,
    ExpenseClaim,
    Payment)
from .forms import (
    OrganizationForm,
    TaxRateForm,
    EstimateForm,
    EstimateLineFormSet,
    InvoiceForm,
    InvoiceLineFormSet,
    BillForm,
    BillLineFormSet,
    ExpenseClaimForm,
    ExpenseClaimLineFormSet,
    PaymentForm)
from .utils import (
    organization_manager,
    EstimateNumberGenerator,
    InvoiceNumberGenerator,
    BillNumberGenerator,
    ExpenseClaimNumberGenerator)

logger = logging.getLogger(__name__)


class OrganizationSelectorView(generic.TemplateView):
    template_name = "books/organization_selector.html"

    def get_context_data(self, **kwargs):
        context = super().get_context_data(**kwargs)

        user = self.request.user
        orgas = organization_manager.get_user_organizations(user)
        cumulated_turnovers = (orgas
            .aggregate(sum=Sum('invoices__total_excl_tax'))["sum"]) or D('0')
        cumulated_debts = (orgas
            .aggregate(sum=Sum('bills__total_excl_tax'))["sum"]) or D('0')
        cumulated_profits = cumulated_turnovers - cumulated_debts

        context["organizations_count"] = orgas.count()
        context["organizations_cumulated_turnovers"] = cumulated_turnovers
        context["organizations_cumulated_profits"] = cumulated_profits
        context["organizations_cumulated_active_days"] = 0

        context["organizations"] = orgas
        context["last_invoices"] = Invoice.objects.all()[:10]

        return context


class DashboardView(generic.DetailView):
    template_name = "books/dashboard.html"
    model = Organization
    context_object_name = "organization"

    def get_object(self):
        return organization_manager.get_selected_organization(self.request)

    def get_context_data(self, **kwargs):
        ctx = super().get_context_data(**kwargs)
        organization = self.get_object()
        ctx['invoices'] = (organization.invoices.all()
            .select_related(
                'client',
                'organization')
            .prefetch_related(
                'lines',
                'lines__tax_rate',
                'payments')
            .distinct())
        ctx['bills'] = (organization.bills.all()
            .select_related(
                'client',
                'organization')
            .prefetch_related(
                'lines',
                'lines__tax_rate',
                'payments')
            .distinct())
        return ctx

    def get(self, request, *args, **kwargs):
        orga = organization_manager.get_selected_organization(self.request)
        if orga is None:
            return HttpResponseRedirect(reverse('books:organization-selector'))
        return super().get(request, *args, **kwargs)


class OrganizationListView(generic.ListView):
    template_name = "books/organization_list.html"
    model = Organization
    context_object_name = "organizations"

    def get_queryset(self):
        # only current authenticated user organizations
        return organization_manager.get_user_organizations(self.request.user)


class OrganizationCreateView(generic.CreateView):
    template_name = "books/organization_create_or_update.html"
    model = Organization
    form_class = OrganizationForm
    success_url = reverse_lazy("books:organization-list")

    def form_valid(self, form):
        obj = form.save(commit=False)
        obj.owner = self.request.user
        return super().form_valid(form)


class OrganizationUpdateView(generic.UpdateView):
    template_name = "books/organization_create_or_update.html"
    model = Organization
    form_class = OrganizationForm
    success_url = reverse_lazy("books:organization-list")

    def get_queryset(self):
        # only current authenticated user organizations
        return organization_manager.get_user_organizations(self.request.user)


class OrganizationDetailView(generic.DetailView):
    template_name = "books/organization_detail.html"
    model = Organization
    context_object_name = "organization"

    def get_queryset(self):
        # only current authenticated user organizations
        return organization_manager.get_user_organizations(self.request.user)

    def get_context_data(self, **kwargs):
        ctx = super().get_context_data(**kwargs)
        organization = self.get_object()
        ctx['invoices'] = (organization.invoices.all()
            .select_related('client', 'organization')
            .prefetch_related('lines'))
        ctx['bills'] = (organization.bills.all()
            .select_related('client', 'organization')
            .prefetch_related('lines'))
        return ctx


class OrganizationSelectionView(generic.DetailView):
    model = Organization

    def get_queryset(self):
        # only current authenticated user organizations
        return organization_manager.get_user_organizations(self.request.user)

    def post(self, request, *args, **kwargs):
        orga = self.get_object()
        organization_manager.set_selected_organization(self.request, orga)
        return HttpResponseRedirect(reverse('books:dashboard'))


class TaxRateListView(RestrictToSelectedOrganizationQuerySetMixin,
                      generic.ListView):
    template_name = "books/tax_rate_list.html"
    model = TaxRate
    context_object_name = "tax_rates"


class TaxRateCreateView(AutoSetSelectedOrganizationMixin,
                        generic.CreateView):
    template_name = "books/tax_rate_create_or_update.html"
    model = TaxRate
    form_class = TaxRateForm
    success_url = reverse_lazy("books:tax_rate-list")


class TaxRateUpdateView(AutoSetSelectedOrganizationMixin,
                        generic.UpdateView):
    template_name = "books/tax_rate_create_or_update.html"
    model = TaxRate
    form_class = TaxRateForm
    success_url = reverse_lazy("books:tax_rate-list")


class TaxRateDeleteView(generic.DeleteView):
    template_name = "_generics/delete_entity.html"
    model = TaxRate
    success_url = reverse_lazy('books:tax_rate-list')


class PaymentUpdateView(generic.UpdateView):
    template_name = "books/payment_create_or_update.html"
    model = Payment
    form_class = PaymentForm

    def get_success_url(self):
        related_obj = self.object.content_object
        if isinstance(related_obj, Invoice):
            return reverse("books:invoice-detail", args=[related_obj.pk])
        elif isinstance(related_obj, Bill):
            return reverse("books:bill-detail", args=[related_obj.pk])

        logger.warning("Unsupported related object '{}' for "
                       "payment '{}'".format(self.object, related_obj))
        return reverse("books:dashboard")


class PaymentDeleteView(generic.DeleteView):
    template_name = "_generics/delete_entity.html"
    model = Payment
    success_url = reverse_lazy('books:invoice-list')


class EstimateListView(RestrictToSelectedOrganizationQuerySetMixin,
                       SaleListQuerySetMixin,
                       generic.ListView):
    template_name = "books/estimate_list.html"
    model = Estimate
    context_object_name = "estimates"


class EstimateCreateView(AutoSetSelectedOrganizationMixin,
                         AbstractSaleCreateUpdateMixin,
                         generic.CreateView):
    template_name = "books/bill_create_or_update.html"
    model = Estimate
    form_class = EstimateForm
    formset_class = EstimateLineFormSet
    success_url = reverse_lazy("books:estimate-list")

    def get_form(self, form_class=None):
        form = super().get_form(form_class)
        orga = organization_manager.get_selected_organization(self.request)
        self.restrict_fields_choices_to_organization(form, orga)
        return form

    def get_initial(self):
        initial = super().get_initial()

        orga = organization_manager.get_selected_organization(self.request)
        initial['number'] = EstimateNumberGenerator().next_number(orga)

        return initial


class EstimateUpdateView(AutoSetSelectedOrganizationMixin,
                         AbstractSaleCreateUpdateMixin,
                         generic.UpdateView):
    template_name = "books/estimate_create_or_update.html"
    model = Estimate
    form_class = EstimateForm
    formset_class = EstimateLineFormSet
    success_url = reverse_lazy("books:estimate-list")


class EstimateDeleteView(generic.DeleteView):
    template_name = "_generics/delete_entity.html"
    model = Estimate
    success_url = reverse_lazy('books:estimate-list')


class EstimateDetailView(AbstractSaleDetailMixin,
                         generic.DetailView):
    template_name = "books/estimate_detail.html"
    model = Estimate
    context_object_name = "estimate"

    def get_success_url(self):
        return reverse('books:estimate-detail', args=[self.object.pk])


class InvoiceListView(RestrictToSelectedOrganizationQuerySetMixin,
                      SaleListQuerySetMixin,
                      generic.ListView):
    template_name = "books/invoice_list.html"
    model = Invoice
    context_object_name = "invoices"


class InvoiceCreateView(AutoSetSelectedOrganizationMixin,
                        AbstractSaleCreateUpdateMixin,
                        generic.CreateView):
    template_name = "books/invoice_create_or_update.html"
    model = Invoice
    form_class = InvoiceForm
    formset_class = InvoiceLineFormSet
    success_url = reverse_lazy("books:invoice-list")

    def get_form(self, form_class=None):
        form = super().get_form(form_class)

accounting/templates/accounting/books/bill_list.html
{% extends "accounting/layout.html" %}
{% load currency_filters %}

{% block content %}
    <h1 class="page-header">Bills <small>which belong to you</small></h1>

    {% include "books/_generics/sale_list.html" with sales=bills detailed=True %}

    <a href="{% url 'books:bill-create' %}" class="btn btn-primary btn-lg" role="button">
        Add a bill
    </a>
{% endblock content %}

accounting/templates/accounting/books/dashboard.html
{% extends "accounting/layout.html" %}
{% load currency_filters %}

{% block content %}
    <h1 class="page-header">
        {{ organization.display_name }} <small>/ organization detail</small>
        <div class="btn-group pull-right">
            <a href="{% url 'books:organization-edit' organization.pk %}" class="btn btn-default" role="button">Edit</a>
        </div>
    </h1>

    <div class="row placeholders">
        <div class="col-xs-6 col-sm-3">
            <div class="figure">
                <h4>{{ organization.turnover_excl_tax|currency|default:"-" }}</h4>
                <span class="text-muted">Turnover</span>
            </div>
        </div>
        <div class="col-xs-6 col-sm-3">
            <div class="figure">
                <h4>{{ organization.profits|currency|default:"-" }}</h4>
                <span class="text-muted">Profits</span>
            </div>
        </div>
        <div class="col-xs-6 col-sm-3">
            <div class="figure">
                <h4>{{ organization.tax_provisionning|currency|default:0 }}</h4>
                <span class="text-muted">Tax Provisionning</span>
            </div>
        </div>
        <div class="col-xs-6 col-sm-3">
            <div class="figure">
                <h4>{{ organization.overdue_total|currency|default:0 }}</h4>
                <span class="text-muted">Due payments</span>
            </div>
        </div>
    </div>

    <div class="row">
        <div class="col-xs-12 col-sm-6">
            <div class="panel panel-default">
                <div class="panel-heading overflow-box">
                    <h4 class="pull-left">
                        Invoices <small>/ what you earn</small>
                    </h4>
                    <div class="btn-group pull-right">
                        <a href="{% url 'books:invoice-create' %}" class="btn btn-primary btn-md" role="button">
                            Add an invoice
                        </a>
                    </div>
                </div>
                {% include "books/_generics/sale_list.html" with sales=invoices hide_edit=True %}
            </div>
        </div>
        <div class="col-xs-12 col-sm-6">
            <div class="panel panel-default">
                <div class="panel-heading overflow-box">
                    <h4 class="pull-left">Bills <small> / what you owe</small></h4>
                    <div class="btn-group pull-right">
                        <a href="{% url 'books:bill-create' %}" class="btn btn-primary btn-md" role="button">
                            Add an bill
                        </a>
                    </div>
                </div>
                {% include "books/_generics/sale_list.html" with sales=bills hide_edit=True %}
            </div>
        </div>
    </div>
{% endblock content %}

accounting/templates/accounting/books/estimate_detail.html
{% extends "accounting/layout.html" %}

{% block head %}
    {{ block.super }}

    {# NB: because the payment form is a subform it won't output the correct assets, so we explicitly put it there #}
    <link rel="stylesheet" href="{% static 'css/datetimepicker.css' %}">
    <script src="{% static 'js/bootstrap-datetimepicker.js' %}"></script>

    {{ form.media }}
{% endblock %}

{% block content %}
    <h1 class="page-header">
        Estimate #{{ estimate.number }} <small>/ detail</small>
        <div class="btn-group pull-right">
            <a href="{% url 'books:estimate-edit' estimate.pk %}" class="btn btn-default" role="button">Edit</a>
            <a href="{% url 'books:estimate-delete' estimate.pk %}" class="btn btn-danger" role="button">Supprimer</a>
        </div>
    </h1>

    {% include "books/_generics/sale_detail.html" with object=estimate lines=lines form=form %}

{% endblock content %}

accounting/templates/accounting/books/estimate_list.html
{% extends "accounting/layout.html" %}
{% load currency_filters %}

{% block content %}
    <h1 class="page-header">Estimates <small>which belong to you</small></h1>

    {% include "books/_generics/sale_list.html" with sales=estimates detailed=True %}

    <a href="{% url 'books:estimate-create' %}" class="btn btn-primary btn-lg" role="button">
        Add a estimate
    </a>
{% endblock content %}

accounting/templates/accounting/books/expense_claim_create_or_update.html
{% extends "accounting/layout.html" %}
{% load static bootstrap3 introspection_filters %}

{% block head %}
    {{ block.super }}
    {{ form.media }}
{% endblock %}

{% block content %}
    <h1 class="page-header">Create a {{ form|get_form_model_verbose_name }}</h1>

    <form action="." method="post" class="form">
        {% csrf_token %}

        {% include "accounting/_partials/form_fields.html" with form=form %}

        <h2 class="page-header">Content</h2>
        {{ line_formset.management_form }}
        {{ line_formset.non_field_errors }}
        <table class="table table-striped table-bordered">
            <thead>
                <th>#</th>
                <th>Label</th>
                <th>Description</th>
                <th>Unit (excl. tax)</th>
                <th>Qt.</th>
                <th>Tax rate</th>
                <th>Total</th>
            </thead>
            <tbody>
            {% for line_form in line_formset %}
                <tr class="formset-form">
                    <td class="col-md-0 counter">
                        {{ forloop.counter }}
                        {{ line_form.id }}
                    </td>
                    <td class="col-md-2">
                        {% bootstrap_field line_form.label show_label=False %}
                    </td>
                    <td class="col-md-4">
                        {% bootstrap_field line_form.description show_label=False %}
                    </td>
                    <td class="col-md-2">
                        {% bootstrap_field line_form.unit_price_excl_tax show_label=False %}
                    </td>
                    <td class="col-md-1">
                        {% bootstrap_field line_form.quantity show_label=False %}
                    </td>
                    <td class="col-md-1">
                        {% bootstrap_field line_form.tax_rate show_label=False %}
                    </td>
                    <td></td>
                </tr>
            {% endfor %}
            </tbody>
        </table>

        {% buttons layout='vertical' %}
            <button type="submit" class="btn btn-success">
                {% bootstrap_icon "star" %} Create
            </button>
        {% endbuttons %}
    </form>
{% endblock content %}

{% block scripts %}
    {{ block.super }}
    <script src="{% static 'accounting/js/jquery.formset.js' %}"></script>
    <script src="{% static 'accounting/js/books/invoice_or_bill_create.js' %}"></script>
{% endblock %}

accounting/templates/accounting/books/expense_claim_detail.html
{% extends "accounting/layout.html" %}
{% load static %}

{% block head %}
    {{ block.super }}

    {# NB: because the payment form is a subform it won't output the correct assets, so we explicitly put it there #}
    <link rel="stylesheet" href="{% static 'css/datetimepicker.css' %}">
    <script src="{% static 'js/bootstrap-datetimepicker.js' %}"></script>

    {{ form.media }}
{% endblock %}

{% block content %}
    <h1 class="page-header">
        Expense claim #{{ expense_claim.number }} <small>/ detail</small>
        <div class="btn-group pull-right">
            <a href="{% url 'books:expense_claim-edit' expense_claim.pk %}" class="btn btn-default" role="button">Edit</a>
            <a href="{% url 'books:expense_claim-delete' expense_claim.pk %}" class="btn btn-danger" role="button">Supprimer</a>
        </div>
    </h1>

    {% include "books/_generics/sale_detail.html" with object=expense_claim lines=lines payments=expense_claim.payments.all form=form %}

{% endblock content %}

accounting/templates/accounting/books/expense_claim_list.html
{% extends "accounting/layout.html" %}
{% load currency_filters %}

{% block content %}
    <h1 class="page-header">Expense claims <small>which belong to you</small></h1>

    {% include "books/_partials/expense_claim_list.html" with sales=expense_claims detailed=True %}

    <a href="{% url 'books:expense_claim-create' %}" class="btn btn-primary btn-lg" role="button">
        Add an Expense claim
    </a>
{% endblock content %}

accounting/templates/accounting/books/invoice_create_or_update.html
{% extends "accounting/layout.html" %}
{% load static bootstrap3 introspection_filters %}

{% block head %}
    {{ block.super }}
    {{ form.media }}
{% endblock %}

{% block content %}
    <h1 class="page-header">Create an {{ form|get_form_model_verbose_name }}</h1>

    <form action="." method="post" class="form">
        {% csrf_token %}

        {% include "accounting/_partials/form_fields.html" with form=form %}

        <h2 class="page-header">Content</h2>
        {{ line_formset.management_form }}
        {{ line_formset.non_field_errors }}
        <table class="table table-striped table-bordered">
            <thead>
                <th>#</th>
                <th>Label</th>
                <th>Description</th>
                <th>Unit (excl. tax)</th>
                <th>Qt.</th>
                <th>Tax rate</th>
                <th>Total</th>
            </thead>
            <tbody>
            {% for line_form in line_formset %}
                <tr class="formset-form">
                    <td class="col-md-0 counter">
                        {{ forloop.counter }}
                        {{ line_form.id }}
                    </td>
                    <td class="col-md-2">
                        {% bootstrap_field line_form.label show_label=False %}
                    </td>
                    <td class="col-md-4">
                        {% bootstrap_field line_form.description show_label=False %}
                    </td>
                    <td class="col-md-2">
                        {% bootstrap_field line_form.unit_price_excl_tax show_label=False %}
                    </td>
                    <td class="col-md-1">
                        {% bootstrap_field line_form.quantity show_label=False %}
                    </td>
                    <td class="col-md-1">
                        {% bootstrap_field line_form.tax_rate show_label=False %}
                    </td>
                    <td>{{ line_form.DELETE }}</td>
                </tr>
            {% endfor %}
            </tbody>
        </table>

        {% buttons layout='vertical' %}
            <button type="submit" class="btn btn-success">
                {% bootstrap_icon "star" %} Create
            </button>
        {% endbuttons %}
    </form>
{% endblock content %}

{% block scripts %}
    {{ block.super }}
    <script src="{% static 'accounting/js/jquery.formset.js' %}"></script>
    <script src="{% static 'accounting/js/books/invoice_or_bill_create.js' %}"></script>
{% endblock %}

accounting/templates/accounting/books/invoice_list.html
{% extends "accounting/layout.html" %}
{% load currency_filters %}

{% block content %}
    <h1 class="page-header">Invoices <small>which belong to you</small></h1>

    {% include "books/_generics/sale_list.html" with sales=invoices detailed=True %}

    <a href="{% url 'books:invoice-create' %}" class="btn btn-primary btn-lg" role="button">
        Add an invoice
    </a>
{% endblock content %}

accounting/templates/accounting/books/organization_create_or_update.html
{% extends "_generics/form.html" %}

accounting/templates/accounting/books/organization_list.html
{% extends "accounting/layout.html" %}
{% load currency_filters %}

{% block content %}
    <h1 class="page-header">Organizations <small>which belong to you</small></h1>

    <table class="table table-striped">
        <thead>
            <tr>
                <th>#</th>
                <th>Display name</th>
                <th>Legal name</th>
                <th>Turnover</th>
                <th class="text-right">Actions</th>
            </tr>
        </thead>
        <tbody>
            {% for orga in organizations %}
            <tr>
                <td>{{ orga.id }}</td>
                <td>{{ orga.display_name }}</td>
                <td>{{ orga.legal_name }}</td>
                <td>{{ orga.turnover_excl_tax|currency|default:"-" }}</td>
                <td class="text-right">
                    <a href="{% url 'books:organization-detail' orga.pk %}" class="btn btn-success btn-sm" role="button">View</a>
                    <a href="{% url 'books:organization-edit' orga.pk %}" class="btn btn-default btn-sm" role="button">Edit</a>
                </td>
            </tr>
            {% endfor %}
        </tbody>
    </table>

    <a href="{% url 'books:organization-create' %}" class="btn btn-primary btn-lg" role="button">
        Add an organization
    </a>
{% endblock content %}

accounting/templates/accounting/books/organization_selector.html
{% extends "accounting/layout.html" %}
{% load currency_filters %}

{% block container %}
<div class="container-fluid">
    <div class="row">
        <div class="col-sm-12 main">
            <h1 class="page-header text-center">Organization Selector</h1>

            <div class="row">
                {% for orga in organizations %}
                <div class="col-md-4">
                    <div class="panel panel-primary">
                        <div class="panel-heading">
                            <h3 class="panel-title">
                                {% ifequal orga.owner request.user %}
                                <span class="label label-warning pull-right">owned</span>
                                {% else %}
                                <span class="label label-info pull-right">member</span>
                                {% endifequal %}
                                {{ orga.display_name }}
                            </h3>
                        </div>
                        <div class="panel-body">
                            <dl class="dl-horizontal">

                                <dt>Turn over (excl. tax)</dt>
                                <dd>{{ orga.turnover_excl_tax|currency|default:"-" }}</dd>

                                <dt>Due payments</dt>
                                <dd>{{ orga.overdue_total|currency|default:0 }}</dd>

                            </dl>
                            <form action="{% url 'books:organization-select' orga.pk %}" method="post">
                                {% csrf_token %}
                                <button type="submit" class="btn btn-success btn-block" role="button">Select</button>
                            </form>
                        </div>
                    </div>
                </div>
                {% endfor %}
                <div class="col-md-4">
                    <div class="panel panel-default">
                        <div class="panel-heading">
                            <h3 class="panel-title">Add an organization</h3>
                        </div>
                        <div class="panel-body">
                            <a class="btn btn-default btn-block" role="button" href="{% url 'books:organization-create' %}">New organization</a>
                        </div>
                    </div>
                </div>
            </div>
        </div>
    </div>
</div>
{% endblock container %}

accounting/templates/accounting/books/tax_rate_create_or_update.html
{% extends "_generics/form.html" %}

accounting/templates/accounting/books/tax_rate_list.html
{% extends "accounting/layout.html" %}
{% load currency_filters %}

{% block content %}
    <h1 class="page-header">Tax Rates <small>which belong to you</small></h1>

    {% include "books/_partials/tax_rate_list.html" with tax_rates=tax_rates %}

    <a href="{% url 'books:tax_rate-create' %}" class="btn btn-primary btn-lg" role="button">
        Add a Tax rate
    </a>
{% endblock content %}